import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../common";
export declare type CollectionSecurityPolicyStruct = {
    transferSecurityLevel: PromiseOrValue<BigNumberish>;
    operatorWhitelistId: PromiseOrValue<BigNumberish>;
    permittedContractReceiversId: PromiseOrValue<BigNumberish>;
};
export declare type CollectionSecurityPolicyStructOutput = [
    number,
    BigNumber,
    BigNumber
] & {
    transferSecurityLevel: number;
    operatorWhitelistId: BigNumber;
    permittedContractReceiversId: BigNumber;
};
export interface CreatorTokenBaseInterface extends utils.Interface {
    functions: {
        "DEFAULT_OPERATOR_WHITELIST_ID()": FunctionFragment;
        "DEFAULT_TRANSFER_SECURITY_LEVEL()": FunctionFragment;
        "DEFAULT_TRANSFER_VALIDATOR()": FunctionFragment;
        "getPermittedContractReceivers()": FunctionFragment;
        "getSecurityPolicy()": FunctionFragment;
        "getTransferValidator()": FunctionFragment;
        "getWhitelistedOperators()": FunctionFragment;
        "isContractReceiverPermitted(address)": FunctionFragment;
        "isOperatorWhitelisted(address)": FunctionFragment;
        "isTransferAllowed(address,address,address)": FunctionFragment;
        "setToCustomSecurityPolicy(uint8,uint120,uint120)": FunctionFragment;
        "setToCustomValidatorAndSecurityPolicy(address,uint8,uint120,uint120)": FunctionFragment;
        "setToDefaultSecurityPolicy()": FunctionFragment;
        "setTransferValidator(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "DEFAULT_OPERATOR_WHITELIST_ID" | "DEFAULT_TRANSFER_SECURITY_LEVEL" | "DEFAULT_TRANSFER_VALIDATOR" | "getPermittedContractReceivers" | "getSecurityPolicy" | "getTransferValidator" | "getWhitelistedOperators" | "isContractReceiverPermitted" | "isOperatorWhitelisted" | "isTransferAllowed" | "setToCustomSecurityPolicy" | "setToCustomValidatorAndSecurityPolicy" | "setToDefaultSecurityPolicy" | "setTransferValidator"): FunctionFragment;
    encodeFunctionData(functionFragment: "DEFAULT_OPERATOR_WHITELIST_ID", values?: undefined): string;
    encodeFunctionData(functionFragment: "DEFAULT_TRANSFER_SECURITY_LEVEL", values?: undefined): string;
    encodeFunctionData(functionFragment: "DEFAULT_TRANSFER_VALIDATOR", values?: undefined): string;
    encodeFunctionData(functionFragment: "getPermittedContractReceivers", values?: undefined): string;
    encodeFunctionData(functionFragment: "getSecurityPolicy", values?: undefined): string;
    encodeFunctionData(functionFragment: "getTransferValidator", values?: undefined): string;
    encodeFunctionData(functionFragment: "getWhitelistedOperators", values?: undefined): string;
    encodeFunctionData(functionFragment: "isContractReceiverPermitted", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "isOperatorWhitelisted", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "isTransferAllowed", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<string>
    ]): string;
    encodeFunctionData(functionFragment: "setToCustomSecurityPolicy", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "setToCustomValidatorAndSecurityPolicy", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "setToDefaultSecurityPolicy", values?: undefined): string;
    encodeFunctionData(functionFragment: "setTransferValidator", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "DEFAULT_OPERATOR_WHITELIST_ID", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "DEFAULT_TRANSFER_SECURITY_LEVEL", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "DEFAULT_TRANSFER_VALIDATOR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPermittedContractReceivers", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getSecurityPolicy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTransferValidator", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getWhitelistedOperators", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isContractReceiverPermitted", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isOperatorWhitelisted", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isTransferAllowed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setToCustomSecurityPolicy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setToCustomValidatorAndSecurityPolicy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setToDefaultSecurityPolicy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setTransferValidator", data: BytesLike): Result;
    events: {
        "TransferValidatorUpdated(address,address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "TransferValidatorUpdated"): EventFragment;
}
export interface TransferValidatorUpdatedEventObject {
    oldValidator: string;
    newValidator: string;
}
export declare type TransferValidatorUpdatedEvent = TypedEvent<[
    string,
    string
], TransferValidatorUpdatedEventObject>;
export declare type TransferValidatorUpdatedEventFilter = TypedEventFilter<TransferValidatorUpdatedEvent>;
export interface CreatorTokenBase extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: CreatorTokenBaseInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        DEFAULT_OPERATOR_WHITELIST_ID(overrides?: CallOverrides): Promise<[BigNumber]>;
        DEFAULT_TRANSFER_SECURITY_LEVEL(overrides?: CallOverrides): Promise<[number]>;
        DEFAULT_TRANSFER_VALIDATOR(overrides?: CallOverrides): Promise<[string]>;
        getPermittedContractReceivers(overrides?: CallOverrides): Promise<[string[]]>;
        getSecurityPolicy(overrides?: CallOverrides): Promise<[CollectionSecurityPolicyStructOutput]>;
        getTransferValidator(overrides?: CallOverrides): Promise<[string]>;
        getWhitelistedOperators(overrides?: CallOverrides): Promise<[string[]]>;
        isContractReceiverPermitted(receiver: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        isOperatorWhitelisted(operator: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        isTransferAllowed(caller: PromiseOrValue<string>, from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        setToCustomSecurityPolicy(level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setToCustomValidatorAndSecurityPolicy(validator: PromiseOrValue<string>, level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setToDefaultSecurityPolicy(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setTransferValidator(transferValidator_: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    DEFAULT_OPERATOR_WHITELIST_ID(overrides?: CallOverrides): Promise<BigNumber>;
    DEFAULT_TRANSFER_SECURITY_LEVEL(overrides?: CallOverrides): Promise<number>;
    DEFAULT_TRANSFER_VALIDATOR(overrides?: CallOverrides): Promise<string>;
    getPermittedContractReceivers(overrides?: CallOverrides): Promise<string[]>;
    getSecurityPolicy(overrides?: CallOverrides): Promise<CollectionSecurityPolicyStructOutput>;
    getTransferValidator(overrides?: CallOverrides): Promise<string>;
    getWhitelistedOperators(overrides?: CallOverrides): Promise<string[]>;
    isContractReceiverPermitted(receiver: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    isOperatorWhitelisted(operator: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    isTransferAllowed(caller: PromiseOrValue<string>, from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    setToCustomSecurityPolicy(level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setToCustomValidatorAndSecurityPolicy(validator: PromiseOrValue<string>, level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setToDefaultSecurityPolicy(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setTransferValidator(transferValidator_: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        DEFAULT_OPERATOR_WHITELIST_ID(overrides?: CallOverrides): Promise<BigNumber>;
        DEFAULT_TRANSFER_SECURITY_LEVEL(overrides?: CallOverrides): Promise<number>;
        DEFAULT_TRANSFER_VALIDATOR(overrides?: CallOverrides): Promise<string>;
        getPermittedContractReceivers(overrides?: CallOverrides): Promise<string[]>;
        getSecurityPolicy(overrides?: CallOverrides): Promise<CollectionSecurityPolicyStructOutput>;
        getTransferValidator(overrides?: CallOverrides): Promise<string>;
        getWhitelistedOperators(overrides?: CallOverrides): Promise<string[]>;
        isContractReceiverPermitted(receiver: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        isOperatorWhitelisted(operator: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        isTransferAllowed(caller: PromiseOrValue<string>, from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        setToCustomSecurityPolicy(level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setToCustomValidatorAndSecurityPolicy(validator: PromiseOrValue<string>, level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setToDefaultSecurityPolicy(overrides?: CallOverrides): Promise<void>;
        setTransferValidator(transferValidator_: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "TransferValidatorUpdated(address,address)"(oldValidator?: null, newValidator?: null): TransferValidatorUpdatedEventFilter;
        TransferValidatorUpdated(oldValidator?: null, newValidator?: null): TransferValidatorUpdatedEventFilter;
    };
    estimateGas: {
        DEFAULT_OPERATOR_WHITELIST_ID(overrides?: CallOverrides): Promise<BigNumber>;
        DEFAULT_TRANSFER_SECURITY_LEVEL(overrides?: CallOverrides): Promise<BigNumber>;
        DEFAULT_TRANSFER_VALIDATOR(overrides?: CallOverrides): Promise<BigNumber>;
        getPermittedContractReceivers(overrides?: CallOverrides): Promise<BigNumber>;
        getSecurityPolicy(overrides?: CallOverrides): Promise<BigNumber>;
        getTransferValidator(overrides?: CallOverrides): Promise<BigNumber>;
        getWhitelistedOperators(overrides?: CallOverrides): Promise<BigNumber>;
        isContractReceiverPermitted(receiver: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        isOperatorWhitelisted(operator: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        isTransferAllowed(caller: PromiseOrValue<string>, from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        setToCustomSecurityPolicy(level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setToCustomValidatorAndSecurityPolicy(validator: PromiseOrValue<string>, level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setToDefaultSecurityPolicy(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setTransferValidator(transferValidator_: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        DEFAULT_OPERATOR_WHITELIST_ID(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        DEFAULT_TRANSFER_SECURITY_LEVEL(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        DEFAULT_TRANSFER_VALIDATOR(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPermittedContractReceivers(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getSecurityPolicy(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTransferValidator(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getWhitelistedOperators(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isContractReceiverPermitted(receiver: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isOperatorWhitelisted(operator: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isTransferAllowed(caller: PromiseOrValue<string>, from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        setToCustomSecurityPolicy(level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setToCustomValidatorAndSecurityPolicy(validator: PromiseOrValue<string>, level: PromiseOrValue<BigNumberish>, operatorWhitelistId: PromiseOrValue<BigNumberish>, permittedContractReceiversAllowlistId: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setToDefaultSecurityPolicy(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setTransferValidator(transferValidator_: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
